<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <title>פגישה 9 - פונקציות ומשתנים מקומיים</title>
 
  <meta http-equiv="content-type"
 content="text/html; charset=UTF-8">
 
  <link href="lec.css" rel="stylesheet" type="text/css">
<!-- LINKS --><!-- TOC<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <title>פגישה 9 - פונקציות ומשתנים מקומיים</title>
  <LINK href="toc.css" rel="stylesheet" type="text/css">           
  <link rel="next" href="node1.html#h">
  <link rel="first" href="node1.html#h">
  <link rel="start" href="node1.html#h">

  <meta http-equiv="content-type"  content="text/html; charset=UTF-8">
</head>
<body>
גרסה 1.1
<h1>פגישה 9 - פונקציות ומשתנים מקומיים</h1>
<div class="start"><a href="node1.html#h">[לחצו כאן כדי להתחיל]</a></div>
<div class="note">הרצאה זו קיימת גם כ-<a href="meeting9-functions.html">קובץ HTML
אחד גדול</a>.</div>
<h2>תוכן העניינים</h2>
<toc/>
<address><a href="http://validator.w3.org/check/referer"><img src="http://www.w3.org/Icons/valid-html401" alt="Valid HTML 4.01!" height="31" width="88"></a>נכתב על ידי <a href="mailto:choo@actcom.co.il">גיא קרן</a><br>
</address>
</body>
</html>
TOC -->
</head>
<body>
  
גרסה 1.1
<h1>פגישה 9 - פונקציות ומשתנים מקומיים</h1>
  <!-- BEGIN -->                  
<h2><a name="function"></a>שיעורון ה' - לפונקציה שלי שלוש קריאות...</h2>
                   
<ul>
  <li>אחד הדברים המרגיזים ביותר בתוכנית הוא הצורך לכתוב את אותם קטעי קוד שוב ושוב</li>
  <li>שפות תיכנות מאפשרות להימנע מכך על-ידי איסוף הקוד המשוכפל לתוך פונקציה</li>
  <li>ובשפת פייתון, להגדרת פונקציה בשם "my_function" המדפיסה הודעה:
    <div dir=ltr><pre>
    &gt;&gt;&gt; def my_function():
    ...     print "this is my function"
    ... 
    </pre></div>
    וכדי להפעיל את הפונקציה:
    <div dir=ltr><pre>
    &gt;&gt;&gt; my_function()
    this is my function
    </pre></div>
      </li>

</ul>

<h3><a name="function_two_calls"></a>הפעלת פונקציה מספר פעמים</h3>
                   
<ul>
  <li>ניקח פונקציה מורכבת יותר, המציירת מעין כוכב על המסך:
    <div dir=ltr><pre>
    &gt;&gt;&gt; def print_stars():
    ...     print " *"  
    ...     print "* *"
    ...     print " * "
    ... 
    </pre></div>
    כעת ניתן להדפיס כמה כוכבים בקלות:
    <div dir=ltr><pre>
    &gt;&gt;&gt; print_stars(); print_stars() 
     *
    * *
     * 
     *
    * *
     * 
    </pre></div>
    (סימן ה-; (נקודה פסיק) משמש להפרדה בין שתי פקודות באותה השורה).
      </li>
           
</ul>
                  
<h3><a name="function_parameters"></a>פרמטרים לפונקציה</h3>
     
<ul>
     <li>ניתן להעביר לפונקציה פרמטרים - נתונים שישפיעו על אופן פעולתה.</li>
     <li>למשל, פונקציה המדפיסה כוכביות בכמות הנקבעת לפי פרמטר:
    <div dir=ltr><pre>
     def print_n_stars(i):
         while i &gt; 0:
             print "*",
             i = i - 1
         print ""
    </pre></div>
      (שימו לב - סימן ה-, (פסיק) בסיום פקודת הדפסה מורה לפייתון לא לרדת שורה.
       שורת ההדפסה של המחרוזת הריקה, אחרי הלולאה, מורידה את הסמן שורה).
      </li>
     <li>ולשם הפעלת הפונקציה:
    <div dir=ltr><pre>
    &gt;&gt;&gt; print_n_stars(1)
    *
    &gt;&gt;&gt; print_n_stars(5)
    * * * * *
    </pre></div>
      </li>
     <li>הפרמטר לפונקציה הוא משתנה מיוחד - גם אם הפונקציה משנה אותו, הדבר
         אינו מורגש מחוץ לפונקציה. הדבר יהיה מובן יותר בעוד דקותיים...</li>
</li>
     
</ul>
                    
<h3><a name="function_retval"></a>החזרת ערך מפונקציה</h3>
     
<ul>
     <li>כמו שפונקציה יכולה לקבל פרמטרים, היא יכולה להחזיר ערכים.</li>
     <li>על מנת להחזיר ערך מתוך הפונקציה, יש להשתמש בפקודה return:
    <div dir=ltr><pre>
     def add_one(i):
         return i + 1
    </pre></div>
      (הגדר פונקציה, שבהינתן פרמטר מספרי, מחזירה ערך הגדול ממנו באחד).
     </li>
     <li>כשפונקציה מחזירה ערך, ניתן לקרוא לה בתוך כל ביטוי מתאים. למשל:
    <div dir=ltr><pre>
    &gt;&gt;&gt; print add_one(5)
    6
    &gt;&gt;&gt; i = add_one(7)
    &gt;&gt;&gt; print i
    7
    </pre></div>
     </li>
     <li>שימו לב: אם הפונקציה אמורה להחזיר מספר, אבל השתמשנו בה בביטוי המצפה
         למחרוזת - נקבל שגיאה:
    <div dir=ltr><pre>
    &gt;&gt;&gt; str = "5 plus 1 is " + add_one(5)
    Traceback (most recent call last):
      File "&lt;stdin&gt;", line 1, in ?
    TypeError: cannot concatenate 'str' and 'int' objects
    </pre></div>
      </li>
     <li>אותו הדבר במקרה ההפוך - לא ניתן להשתמש בפונקציה המחזירה מחרוזת, בביטוי
         המצפה לקבל מספר.
      </li>
     
</ul>
                    
<h3><a name="range"></a>כלי קטן - טווחים</h3>
     
<ul>
     <li>פייתון מספקת כלי שימושי במיוחד עבור לולאות - טווחים.</li>
     <li>טווח מאפשר להגדיר קבוצה של מספרים עוקבים, עם או בלי דילוגים.</li>
     <li>הגדרת טווח מתבצעת על-ידי שימוש בפונקציה range:
    <div dir=ltr><pre>
    &gt;&gt;&gt; range(0, 10)
    [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]
    </pre></div>
      (קבוצת המספרים בין אפס לעשר, לא כולל עשר).
    <div dir=ltr><pre>
    &gt;&gt;&gt; range(0, 10, 2)
    [0, 2, 4, 6, 8]
    </pre></div>
      (קבוצת המספרים בין אפס לעשר, בדילוג של שניים בין מספר למספר).
     </li>
     <li>ניתן להשתמש בפונקציית הטווח בשילוב עם לולאת for:
    <div dir=ltr><pre>
    &gt;&gt;&gt; i = 0          
    &gt;&gt;&gt; for j in range(0, 10):
    ...     i = i + j
    ... 
    &gt;&gt;&gt; print i
    45
    </pre></div>
    (סיכום כל המספרים בין אפס לעשר, לא כולל עשר).
      </li>
     <li>זה נראה מוזר ש-range לא מחזירה את המספר העליון בתחום - בעתיד נוכל
         לראות מדוע זה כך.</li>
     
</ul>
                    
<h3><a name="game_5"></a>משחק חמישי - צייר לי משולש, או ריבוע, או משהו...</h3>
     
<ul>
     <li>כיתבו תוכנית, המציירת על המסך צורה גאומטרית לפי בחירתכם. למשל:
         <pre>
          *
          **
          ***
          *****
          ******
          *******
          ********
          *********
         </pre>
         </li>
     <li>הדרכה: ראשית, כיתבו פונקציה המקבלת מספר, ומדפיסה כוכביות בכמות
         המבוקשת.</li>
     <li>התוכנית הראשית תבצע לולאה שבה תקרא לפונקציה מספר פעמים, להדפסת השורות
         השונות.</li>
     <li>השתמשו בטווחים בעת כתיבת הלולאות.</li>
     
</ul>
                    
<h2><a name="params_are_local"></a>שיעורון ו' - משתנים מקומיים - מבחוץ ומבפנים.</h2>
     
<ul>
     <li>כפי שציינו, הפרמטרים של פונקציה הם משתנים מיוחדים - אם משנים אותם בתוך
         הפונקציה, הם לא משפיעים על הערכים שהועברו לפונקציה:
    <div dir=ltr><pre>
    &gt;&gt;&gt; def confusion(i):
    ...     i = i + 1
    ...     print "i: ", i
    ... 
    &gt;&gt;&gt; i = 3
    &gt;&gt;&gt; confusion(i)
    i:  4
    &gt;&gt;&gt; print i
    3
    </pre></div>
</li>
     <li>מה קרה כאן? הפרמטר של הפונקציה, i, הוא למעשה לא אותו ה-i שמצוי מחוץ
         לפונקציה. זהו i אחר, שקיים רק בזמן שהפונקציה פועלת.</li>
     <li>לטריק הקטן הזה קוראים בשם scope - לכל משתנה יש זמן חיים משלו.
     <li>המשתנה i שהוגדר מחוץ לפונקציה נקרא "משתנה גלובלי" - הוא קיים בכל
         התוכנית.</li>
     <li>המשתנה i שהוגדר בתור הפרמטר של הפונקציה נקרא "משתנה מקומי" - הוא קיים
         רק בתוך הפונקציה.</li>
     <li>אפשר לשאול - "בשביל מה זה טוב???"</li>
     
</ul>
                    
<h3><a name="wrong_var_reuse"></a>שימוש שגוי במשתנה אחד לשתי מטרות</h3>
     
<ul>
     <li>כשכותבים תוכנית, צריך להיזהר משימוש באותו המשתנה פעמיים למטרות שונות.
         הנה שגיאה לדוגמא:
    <div dir=ltr><pre>
    &gt;&gt;&gt; i = 0
    &gt;&gt;&gt; while i &lt; 2:
    ...     for i in range(0, 2):
    ...         print "*",
    ...     print
    ...     i = i + 1
    ... 
    * *
    </pre></div>
    (התוכניתן רצה להדפיס ריבוע של 2 כוכביות על 2 כוכביות. בפועל, הודפסה שורה
     אחת בלבד).
      </li>
</ul>
                    
<h3><a name="local_vars"></a>שימוש במשתנים מקומיים</h3>
     
<ul>
     <li>עכשיו נראה את אותו הדבר, בעזרת פונקציה:
    <div dir=ltr><pre>
    &gt;&gt;&gt; def print_stars(i):
    ...     for i in range(0, i):
    ...         print "*",
    ...     print
    ... 
    &gt;&gt;&gt; i = 0
    &gt;&gt;&gt; while i &lt; 2:
    ...     print_stars(2)
    ...     i = i + 1
    ... 
    * *
    * *
    </pre></div>
     </li>
     
</ul>
                    
<h3><a name="local_vars_more"></a>עוד על משתנים מקומיים</h3>
     
<ul>
     <li>אמנם בתוכנית שלנו, יכולנו לקרוא לפרמטר של הפונקציה בשם j,
         ולמנוע התנגשויות אפשריות.</li>
     <li>אולם, ככל שהתוכנית גדלה, קשה יותר לעקוב אחרי השימוש בשמות משתנים
        ולמנוע התנגשויות כאלו.</li>
     <li>השימוש במשתנים מקומיים מאפשר לנו לדעת שפייתון מגינה עלינו מפני
         התנגשויות בין פונקציות שונות.</li>
     <li>כל שנותר לנו לעשות הוא למנוע התנגשויות בתוך פונקציה אחת.</li>
     <li>לפיכך, אם נקפיד שכל פונקציה תהיה קצרה, חיינו יהיו קלים למדי.</li>
     
</ul>
                    
<h3><a name="game_6"></a>משחק שישי - "כמה דני..." - תוכנית למבלבלים מתחילים.</h3>
     
<ul>
     <li>משחק שבא לבחון מי מתבלבל יותר מהר.</li>
     <li>כיתבו תוכנית שכל המשתנים בה נקראים "דני" (danny).</li>
     <li>התוכנית צריכה לבצע משהו שימושי...</li>
     <li>...והמדריכים יצטרכו לנחש מה היא עושה.</li>
     <li>נראה מי יתבלבל יותר - אתם או המדריכים...</li>
     
</ul>
                                                        
<!-- END -->                   
<address><a href="http://validator.w3.org/check/referer"><img
 src="http://www.w3.org/Icons/valid-html401" alt="Valid HTML 4.01!"
 height="31" width="88">
 </a>נכתב על ידי <a href="mailto:choo@actcom.co.il">גיא קרן</a><br>
          </address>
                   
</body>
</html>
